"""Add subscription models migration

Revision ID: 19502fb57466
Revises: 01a37d917ea2
Create Date: 2020-07-21 13:42:16.614355

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = '19502fb57466'
down_revision = '01a37d917ea2'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    # === INVOICES ===
    op.create_table('invoice_status',
                    sa.Column('id', sa.Integer(), nullable=False),
                    sa.Column('name', sa.String(length=50), nullable=True),
                    sa.PrimaryKeyConstraint('id'),
                    sa.UniqueConstraint('id')
    )

    op.create_table('invoices',
                    sa.Column('id', sa.Integer(), nullable=False),
                    sa.Column('user_id', sa.Integer(), nullable=False),
                    sa.Column('paid', sa.Boolean(), nullable=True),
                    sa.Column('status', sa.Integer(), nullable=True),
                    sa.Column('recipe_url', sa.String(length=256), nullable=True),
                    sa.ForeignKeyConstraint(['status'], ['invoice_status.id'], name='fk_invoice_type_id'),
                    sa.ForeignKeyConstraint(['user_id'], ['users.id'], name='fk_user_id'),
                    sa.PrimaryKeyConstraint('id', 'user_id'),
                    sa.UniqueConstraint('id')
    )

    # === CARDS ===
    op.create_table('user_cards',
                    sa.Column('user_id', sa.Integer(), nullable=False),
                    sa.Column('fingerprint', sa.String(length=35), nullable=True),
                    sa.Column('last_transaction_date', sa.DateTime(), nullable=True),
                    sa.Column('first_transaction_date', sa.DateTime(), nullable=True),
                    sa.ForeignKeyConstraint(['user_id'], ['users.id'], name='fk_user_id'),
                    sa.PrimaryKeyConstraint('user_id')
    )

    # === SUBSCRIPTIONS ===
    op.create_table('subscription_status',
                    sa.Column('id', sa.Integer(), nullable=False),
                    sa.Column('name', sa.String(length=50), nullable=True),
                    sa.PrimaryKeyConstraint('id'),
                    sa.UniqueConstraint('id')
    )

    op.create_table('subscription_types',
                    sa.Column('id', sa.Integer(), nullable=False),
                    sa.Column('sub_type', sa.String(length=50), nullable=True),
                    sa.PrimaryKeyConstraint('id'),
                    sa.UniqueConstraint('id')
    )

    op.create_table('users_subscriptions',
                    sa.Column('id', sa.String(length=128), nullable=False),
                    sa.Column('user_id', sa.Integer(), nullable=False),
                    sa.Column('sub_type_id', sa.Integer(), nullable=False),
                    sa.Column('status', sa.Integer(), nullable=False),
                    sa.Column('invoice_id', sa.Integer(), nullable=False),
                    sa.Column('date_start', sa.DateTime(), nullable=True),
                    sa.Column('date_end', sa.DateTime(), nullable=True),
                    sa.ForeignKeyConstraint(['invoice_id'], ['invoices.id'], name='fk_invoices_id'),
                    sa.ForeignKeyConstraint(['status'], ['subscription_status.id'], name='fk_sub_status'),
                    sa.ForeignKeyConstraint(['sub_type_id'], ['subscription_types.id'], name='fk_sub_type_id'),
                    sa.ForeignKeyConstraint(['user_id'], ['users.id'], name='fk_user_id'),
                    sa.PrimaryKeyConstraint('id', 'user_id', 'sub_type_id', 'status', 'invoice_id'),
                    sa.UniqueConstraint('id')
    )

    # === USERS ===
    op.add_column('users', sa.Column('status', sa.String(length=25), nullable=True))

    op.alter_column('users', 'ip',
                    existing_type=postgresql.INET(),
                    type_=sa.String(length=120),
                    existing_nullable=True)
    op.create_unique_constraint(None, 'users', ['id'])
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'users', type_='unique')
    op.alter_column('users', 'ip',
               existing_type=sa.String(length=120),
               type_=postgresql.INET(),
               existing_nullable=True)
    op.drop_column('users', 'status')
    op.drop_table('invoice_status')
    op.drop_table('invoices')
    op.drop_table('subscription_types')
    op.drop_table('subscription_status')
    op.drop_table('users_subscriptions')
    op.drop_table('user_cards')
    # ### end Alembic commands ###
